//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "DigitDetector"
#pragma resource "*.dfm"
TDetectForm *DetectForm;
//---------------------------------------------------------------------------

__fastcall TDetectForm::TDetectForm(TComponent* Owner)
	: TForm(Owner)
{
	mSampleBuffer = new short[80000];
	mDetecting = false ;
}
//---------------------------------------------------------------------------

__fastcall TDetectForm::~TDetectForm()
{
	if( mDetecting )
	{
		delete DigitDetector1 ;
		delete mFile ;
	}

	delete mSampleBuffer ;
}
//---------------------------------------------------------------------------

void __fastcall TDetectForm::open1Click(TObject *Sender)
{
	if( mDetecting )
		return ;

	if( OpenDialog1->Execute() )
	{
		AnsiString file_name = OpenDialog1->FileName ;
		try
		{
			mFile = new TFileStream(file_name, fmOpenRead) ;
			Memo1->Clear() ;
			mDialedNumber = "" ;
			mDetecting = true ;
			Memo1->Lines->Add( "-------- Begin Detecting -------" ) ;
			DigitDetector1->BeginDetect( 0, 0, true, true, true ) ;
		}
		catch ( ... )
		{
			ShowMessage("The file cannot be opened!") ;
		}
	};
}
//---------------------------------------------------------------------------
void __fastcall TDetectForm::DigitDetector1DoSupplyBuffer(TComponent *Sender,
			short *&Buffer, int &Length, bool &IsLastBuffer, int Position)
{
	mFile->Position = Position * 2 ;
	Length = ( mFile->Read( mSampleBuffer, 160000 ) ) / 2 ;
	Buffer = mSampleBuffer ;
	if( Length < 80000 )
		IsLastBuffer = true ;
}
//---------------------------------------------------------------------------
void __fastcall TDetectForm::DigitDetector1DigitDetected(TComponent *Sender,
			char Digit, unsigned TimeTicks, bool IsDTMF)
{
	AnsiString digit ;

	digit = AnsiString(Digit) + ",  at:" + AnsiString(TimeTicks) ;
	if( IsDTMF )
		digit += ", type=Tone" ;
	else
		digit += ", type=Pulse" ;

	Memo1->Lines->Add( digit ) ;
	mDialedNumber += AnsiString( Digit ) ;
}
//---------------------------------------------------------------------------
void __fastcall TDetectForm::DigitDetector1DetectionEnd(TObject *Sender)
{
	delete mFile ;
	Memo1->Lines->Add( "------------ End -------------" ) ;
	Memo1->Lines->Add( " Dialed Numer = " + mDialedNumber ) ;
	mDetecting = false ;
}
//---------------------------------------------------------------------------

void __fastcall TDetectForm::Help1Click(TObject *Sender)
{
	Application->HelpCommand(HELP_CONTENTS, 0);
}
//---------------------------------------------------------------------------

