//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
// todo: food names
#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "SortedStringGrid"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
double gDailyValue[16] = { 1000, 2000, 80, 100, 15, 100, 10, 800, 1000, 2000, 2000, 7000, 1.2, 1.7, 19, 70 } ;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
				: TForm(Owner)
{
	int i, j, k=0 ;
	ComboBox1->ItemIndex = 1 ;

	SortedStringGrid1->Rows[0]->CommaText = " , Weight, Energy, Protein, Carbohydrate, Fiber, Fat, Iron, Calcium, Phosphorus, Potassium, Sodium, Vit.A, Vit.B1, Vit.B2, Niacin, Vit.C";
	SortedStringGrid1->Rows[1]->CommaText = "Item, gr, cal., gr, gr, gr, gr, mg, mg, mg, mg, mg, unit, mg, mg, mg, mg";
	for( i = 1 ; i < SortedStringGrid1->ColCount; i++ )
	{
		SortedStringGrid1->ColumnId[i] = i - 1 ;
	}

	SortedStringGrid1->ColWidths[0] = 120 ;
	SortedStringGrid1->RowHeights[0] = 30 ;
	SortedStringGrid1->Canvas->Font = ComboBox1->Font ;
	for( i = 1 ; i < SortedStringGrid1->ColCount; i++ )
	{
		j = 8 + SortedStringGrid1->Canvas->TextWidth( SortedStringGrid1->Cells[i][0] ) ;
		if( j < 32 )
			j = 32 ;
		SortedStringGrid1->ColWidths[i] = j ;
		k += j + SortedStringGrid1->GridLineWidth;
	}
	SortedStringGrid1->Width = k + 141 ;
	Width = k + 148 ;

	UpdateGrid( 2 );
}
//---------------------------------------------------------------------------

void __fastcall TForm1::NutrientsClick(TObject *Sender)
{
	TMenuItem *item = ((TMenuItem *)Sender) ;
	int i, j ;

	item->Checked = !item->Checked ;
	for( i = 1 ; i < SortedStringGrid1->ColCount ; i++ )
	{
		if( item->Tag == SortedStringGrid1->ColumnId[i] )
		{
			if( item->Checked )
			{
				SortedStringGrid1->Canvas->Font = ComboBox1->Font ;
				j = 8 + SortedStringGrid1->Canvas->TextWidth( SortedStringGrid1->Cells[i][0] ) ;
				if( j < 32 )
					j = 32 ;
				SortedStringGrid1->ColWidths[i] = j ;
			}
			else
			{
				SortedStringGrid1->ColWidths[i] = -1 ;
			}
			continue ;
		}
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SortedStringGrid1KeyUp(TObject *Sender, WORD &Key,
			TShiftState Shift)
{
	if( Shift.Contains(ssCtrl)  &&  Key == VK_DELETE )
	{
		if(IDOK == Application->MessageBox("Remove this item from the list of foods?", "Remove Item", MB_OKCANCEL) )
		{
			int top_row = SortedStringGrid1->TopRow ;
			int row = SortedStringGrid1->Row ;
			SortedStringGrid1->DeleteRow( row ) ;
			SortedStringGrid1->TopRow = top_row;
			SortedStringGrid1->Row = row;
		}
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SortedStringGrid1DrawCell(TObject *Sender,
			int ACol, int ARow, TRect &Rect, TGridDrawState State)
{
	if( ARow <= 1 )
	{
		SortedStringGrid1->Canvas->Font = ComboBox1->Font ;
		SortedStringGrid1->Canvas->TextRect(Rect, Rect.Left+2, Rect.Top, SortedStringGrid1->Cells[ACol][ARow] ) ;
	}

	if( ARow == 0  &&  ACol > 0)
	{
		Rect.Top = Rect.Top + 16 ;
		Rect.Left = Rect.Left + 7 ;
		SortedStringGrid1->Canvas->TextRect(Rect, Rect.Left+2, Rect.Top, gDailyValue[SortedStringGrid1->ColumnId[ACol]] ) ;
		ImageList1->Draw(SortedStringGrid1->Canvas, Rect.Left - 5, Rect.Top + 2, 0, true);
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ComboBox1Change(TObject *Sender)
{
	UpdateGrid( 1 + ComboBox1->ItemIndex );
}
//---------------------------------------------------------------------------

void __fastcall TForm1::UpdateGrid(unsigned int aNormalizeIndex)
{
	int i ,j ;
	double a, b ;
	AnsiString s;

	for( i = 0 ; i < SortedStringGrid1->RowCount; i++ )
	{
		SortedStringGrid1->SetRowAttributes( i, false, false, false );
	}
	SortedStringGrid1->SetRowAttributes( 0, true, true, false );
	SortedStringGrid1->SortRows();
	SortedStringGrid1->SetRowAttributes( 0, false, false, false );

	ReadData();


	for( j = 2 ; j < 66 ; j++)
	{
		b = ( SortedStringGrid1->Cells[aNormalizeIndex][j] ).ToDouble() ;
		for( i = 1 ; i < 17 ; i++ )
		{
			s = SortedStringGrid1->Cells[i][j] ;
			a = s.ToDouble() ;
			a = int(a * 10000.0 / b) ;
			a =a/100.0 ;
			SortedStringGrid1->Cells[i][j] = a ;
		}
	}
	SortedStringGrid1->SortColumns();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SortedStringGrid1CustomCompare(TComponent *Sender,
			AnsiString String1, int ColumnIndex1, int RowIndex1,
			AnsiString String2, int ColumnIndex2, int RowIndex2, int &Result)
{
	if( RowIndex1 == 0 )
	{
		if( SortedStringGrid1->ColumnId[ColumnIndex1] == SortedStringGrid1->ColumnId[ColumnIndex2] )
		{
			Result = 0 ;
		}
		else
		{
			if( SortedStringGrid1->ColumnId[ColumnIndex1] > SortedStringGrid1->ColumnId[ColumnIndex2] )
				Result = 1 ;
			else
				Result = -1 ;
		}
		return ;
	}

	double val1 = String1.ToDouble() ;
	double val2 = String2.ToDouble() ;
	double val3 ;

	val1 = val1 / gDailyValue[SortedStringGrid1->ColumnId[ColumnIndex1]] ;
	val2 = val2 / gDailyValue[SortedStringGrid1->ColumnId[ColumnIndex2]] ;
	val3 = .25 * ( val1 + val2 ) * ( val1 + val2 ) ;

	if( val3 == 0 )
		val3 = 1.0 ;

	if( ( val1 - val2 ) * ( val1 - val2 ) / val3 < .0001 )
	{
		Result = 0 ;
		return ;
	}

	if( String1.ToDouble() > String2.ToDouble() )
		Result = 1 ;
	else
		Result = -1 ;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::ReadData()
{
	AnsiString nutriens[64][17] =
	{
		{
			"Milk:(low fat)",
			"492.00",	"180.00",	"12.00",	"26.00",	"0.00",	"00.00",	"0.20",	"550.00",	"470.00",	"107.00",	"39.00",	"150.00",	"0.20",	"0.85",	"0.40",	"3.00"
		}
		,
		{
			"Chocolate Milk",
			"252.00",	"235.00",	"08.00",	"26.00",	"0.00",	"11.00",	"0.90",	"280.00",	"212.00",	"50.00",	"19.00",	"390.00",	"0.10",	"0.50",	"0.30",	"0.30"
		}
		,
		{
			"Yogurt:(low fat)",
			"250.00",	"120.00",	"8.00",	"13.00",	"0.00",	"4.00",	"0.10",	"295.00",	"270.00",	"50.00",	"19.00",	"170.00",	"0.10",	"0.40",	"0.20",	"0.00"
		}
		,
		{
			"Cream:(low fat)",
			"120.00",	"170.00",	"4.00",	"5.00",	"0.00",	"15.00",	"0.00",	"130.00",	"90.00",	"95.00",	"55.00",	"550.00",	"0.00",	"0.20",	"0.00",	"0.00"
		}
		,
		{
			"Fatty Chease",
			"40.00",	"121.00",	"8.00",	"1.30",	"0.00",	"9.30",	"1.30",	"156.00",	"203.00",	"113.00",	"100.00",	"84.00",	"0.00",	"0.00",	"0.00",	"0.00"
		}
		,
		{
			"Eggs",
			"150.00",	"225.00",	"18.00",	"0.00",	"0.00",	"18.00",	"3.45",	"81.00",	"308.00",	"194.00",	"183.00",	"1770.00",	"0.00",	"0.45",	"0.00",	"0.00"
		}
		,
		{
			"Egg's White",
			"132.00",	"60.00",	"12.00",	"0.00",	"0.00",	"4.00",	"1.00",	"12.00",	"60.00",	"192.00",	"226.00",	"0.00",	"0.00",	"0.40",	"0.00",	"0.00"
		}
		,
		{
			"Butter",
			"14.00",	"100.00",	"0.00",	"0.00",	"0.00",	"11.00",	"0.00",	"2.75",	"0.00",	"3.50",	"120.00",	"462.00",	"0.00",	"0.00",	"0.00",	"0.00"
		}
		,
		{
			"Mayonaise",
			"15.00",	"110.00",	"0.00",	"0.00",	"0.00",	"12.00",	"0.10",	"2.00",	"8.00",	"3.00",	"85.00",	"40.00",	"0.00",	"0.00",	"0.00",	"0.00"
		}
		,
		{
			"Olive Oil",
			"14.00",	"125.00",	"0.00",	"0.00",	"0.00",	"14.00",	"0.00",	"0.00",	"0.00",	"0.00",	"0.00",	"0.00",	"0.00",	"0.00",	"0.00",	"0.00"
		}
		,
		{
			"Salad Sauce",
			"15.00",	"60.00",	"0.00",	"2.00",	"0.00",	"6.00",	"0.10",	"3.00",	"0.00",	"0.00",	"40.00",	"0.00",	"0.00",	"0.00",	"0.00",	"0.00"
		}
		,
		{
			"Lamb's Liver",
			"5.00",	"13.00",	"1.60",	"0.15",	"0.00",	"0.60",	"0.90",	"0.80",	"29.00",	"17.00",	"4.20",	"3700.00",	"0.03",	"0.26",	"1.20",	"1.80"
		}
		,
		{
			"Boiled Carrot",
			"50.00",	"15.00",	"0.30",	"3.30",	"0.30",	"0.00",	"0.20",	"12.50",	"18.00",	"200.00",	"25.00",	"5043.00",	"0.00",	"0.00",	"0.23",	"2.00"
		}
		,
		{
			"Steak(best part)",
			"85.00",	"330.00",	"20.00",	"0.00",	"0.00",	"27.00",	"2.50",	"8.00",	"150.00",	"320.00",	"60.00",	"50.00",	"0.00",	"0.00",	"4.00",	"0.00"
		}
		,
		{
			"Steak",
			"85.00",	"220.00",	"24.00",	"0.00",	"0.00",	"12.00",	"3.00",	"11.00",	"180.00",	"300.00",	"62.00",	"20.00",	"0.00",	"0.00",	"4.80",	"0.00"
		}
		,
		{
			"Chicken(grilled)",
			"85.00",	"185.00",	"23.00",	"0.00",	"0.00",	"9.00",	"1.40",	"10.00",	"250.00",	"350.00",	"50.00",	"260.00",	"0.00",	"0.10",	"7.00",	"0.00"
		}
		,
		{
			"Fried Chicken",
			"85.00",	"245.00",	"25.00",	"0.00",	"0.00",	"15.00",	"1.80",	"13.00",	"218.00",	"320.00",	"50.00",	"200.00",	"0.00",	"0.10",	"5.00",	"0.00"
		}
		,
		{
			"Shish Kebab",
			"115.00",	"480.00",	"24.00",	"0.00",	"0.00",	"35.00",	"3.10",	"10.00",	"140.00",	"275.00",	"75.00",	"0.00",	"0.10",	"0.20",	"4.50",	"0.00"
		}
		,
		{
			"Lamb (boiled)",
			"85.00",	"285.00",	"18.00",	"0.00",	"0.00",	"23.00",	"2.40",	"8.00",	"170.00",	"260.00",	"60.00",	"0.00",	"0.10",	"0.20",	"4.00",	"0.00"
		}
		,
		{
			"Beef",
			"85.00",	"185.00",	"23.00",	"0.00",	"0.00",	"9.00",	"2.70",	"9.00",	"230.00",	"400.00",	"70.00",	"0.00",	"0.00",	"0.20",	"6.00",	"0.00"
		}
		,
		{
			"Fish",
			"85.00",	"135.00",	"16.00",	"6.00",	"0.00",	"5.00",	"0.70",	"11.00",	"200.00",	"510.00",	"56.00",	"0.00",	"0.00",	"0.00",	"2.60",	"0.00"
		}
		,
		{
			"Shrimp",
			"85.00",	"110.00",	"23.00",	"0.00",	"0.00",	"1.00",	"2.60",	"98.00",	"250.00",	"205.00",	"130.00",	"50.00",	"0.00",	"0.00",	"1.90",	"0.00"
		}
		,
		{
			"Tuna:(without oil)",
			"85.00",	"170.00",	"25.00",	"0.00",	"0.00",	"7.00",	"1.20",	"7.00",	"300.00",	"240.00",	"700.00",	"70.00",	"0.00",	"0.10",	"10.00",	"0.00"
		}
		,
		{
			"Boiled Beans",
			"150.00",	"188.00",	"12.00",	"37.00",	"2.50",	"0.00",	"3.75",	"52.50",	"210.00",	"510.00",	"6.00",	"7.50",	"0.20",	"0.09",	"1.10",	"0.00"
		}
		,
		{
			"Savoy:(steamed)",
			"170.00",	"40.00",	"2.00",	"9.00",	"1.30",	"0.00",	"0.80",	"78.00",	"50.00",	"240.00",	"23.00",	"150.00",	"0.00",	"0.00",	"0.30",	"53.00"
		}
		,
		{
			"Strawberries",
			"149.00",	"54.00",	"0.00",	"12.00",	"1.90",	"0.00",	"1.20",	"20.00",	"24.00",	"157.00",	"2.00",	"50.00",	"0.00",	"0.00",	"0.50",	"60.00"
		}
		,
		{
			"Tangerine",
			"114.00",	"40.00",	"1.00",	"10.00",	"1.00",	"0.00",	"0.40",	"33.00",	"23.00",	"110.00",	"2.00",	"420.00",	"0.00",	"0.00",	"0.20",	"30.00"
		}
		,
		{
			"Orange Juice",
			"250.00",	"112.00",	"2.00",	"25.00",	"0.20",	"0.00",	"0.50",	"27.00",	"42.00",	"500.00",	"2.00",	"500.00",	"0.20",	"0.00",	"1.00",	"129.00"
		}
		,
		{
			"Carrot",
			"100.00",	"40.00",	"0.00",	"9.10",	"1.10",	"0.00",	"0.80",	"40.00",	"38.00",	"410.00",	"46.00",	"1000.00",	"0.00",	"0.10",	"0.60",	"6.00"
		}
		,
		{
			"Celery:(boiled)",
			"100.00",	"20.00",	"1.00",	"4.00",	"1.00",	"0.00",	"0.50",	"54.00",	"40.00",	"300.00",	"80.00",	"0.00",	"0.00",	"0.00",	"0.40",	"7.00"
		}
		,
		{
			"Celery",
			"40.00",	"5.00",	"1.00",	"1.00",	"0.30",	"0.00",	"0.20",	"20.00",	"18.00",	"130.00",	"30.00",	"0.00",	"0.00",	"0.00",	"0.20",	"3.00"
		}
		,
		{
			"Cucumber",
			"50.00",	"6.00",	"0.00",	"1.00",	"0.20",	"0.00",	"0.10",	"5.00",	"9.00",	"80.00",	"3.00",	"0.00",	"0.00",	"0.00",	"0.10",	"4.00"
		}
		,
		{
			"Boiled Eggplant",
			"180.00","30.00","2.00","9.00","1.20","0.00","0.90","17.00","60.00","390.00","2.00","10.00","0.00","0.00","0.90","8.00"
		}
		,
		{
			"Lettuce",
			"100.00","13.00","0.00","3.00","0.50","0.00","0.50","20.00","22.00","175.00","9.00","300.00","0.00","0.00","0.30","6.00"
		}
		,
		{
			"Boiled Cabbage",
			"15.00","5.10","0.50","0.80","0.20","0.00","0.12","28.20","7.50","34.00","4.00","1170.00","0.00","0.02","0.16","7.50"
		}
		,
		{
			"Tomatoe",
			"150.00","30.00","1.00","6.00","0.60","0.00","0.90","16.00","40.00","360.00","5.00","2600.00","0.00","0.00","0.80","35.00"
		}
		,
		{
			"Lettuce",
			"100.00","14.00","1.00","2.00","0.50","0.00","2.00","35.00","26.00","260.00","9.00","1900.00","0.00","0.00","0.30","18.00"
		}
		,
		{
			"Melon",
			"380.00","40.00","1.00","9.00","2.20","0.00","0.80","33.00","64.00","910.00","40.00","6000.00","0.00","0.00","1.00","65.00"
		}
		,
		{
			"French Fries",
			"100.00","268.00","4.00","33.00","0.40","14.00","1.10","15.00","100.00","775.00","225.00","0.00","0.10","0.00","2.80","20.00"
		}
		,
		{
			"Baked Potatoe",
			"200.00","160.00","4.00","38.00","0.80","0.00","1.60","22.00","112.00","814.00","6.00","20.00","0.20","0.00","2.40","30.00"
		}
		,
		{
			"Apple",
			"260.00","140.00","0.00","36.00","2.00","0.00","0.80","16.00","26.00","260.00","2.00","100.00","0.00","0.00","0.00","6.00"
		}
		,
		{
			"Banana",
			"250.00","142.00","1.60","38.00","1.50","0.00","1.20","13.00","73.00","650.00","1.60","317.00","0.00","0.00","1.20","17.00"
		}
		,
		{
			"Cherry",
			"228.00","130.00","2.00","30.00","0.60","0.00","0.80","36.00","40.00","540.00","2.00","1240.00","0.00","0.00","0.80","20.00"
		}
		,
		{
			"Dates",
			"72.00","202.00","1.60","54.00","1.40","0.00","2.30","42.00","44.00","520.00","0.40","40.00","0.04","0.08","1.60","0.00"
		}
		,
		{
			"Pears",
			"182.00","100.00","1.00","25.00","2.00","1.00","0.50","13.00","29.00","182.00","3.00","30.00","0.00","0.00","0.00","0.20"
		}
		,
		{
			"Raisin",
			"80.00","230.00","2.00","62.00","0.70","0.00","2.80","50.00","112.00","575.00","19.00","15.00","0.10","0.00","0.40","0.00"
		}
		,
		{
			"Pineapple",
			"122.00","95.00","0.00","26.00","0.40","0.00","0.70","26.00","9.00","150.00","1.00","100.00","0.10","0.00","0.20","11.00"
		}
		,
		{
			"Corn:(boiled)",
			"200.00","170.00","5.00","41.00","1.60","0.00","1.30","10.00","102.00","400.00","472.00","520.00","0.00","0.10","2.40","1.40"
		}
		,
		{
			"Bread",
			"91.00","244.00","8.00","46.00","1.80","3.00","2.20","64.00","132.00","144.00","531.00","0.00","0.22","0.14","2.10","0.00"
		}
		,
		{
			"Plum",
			"180.00","90.00","0.00","21.00","0.60","0.00","0.90","30.00","30.00","300.00","300.00","600.00","0.00","0.00","0.90","9.00"
		}
		,
		{
			"Mushrooms:(boiled)",
			"120.00","12.00","2.00","4.00","0.00","0.00","0.90","8.00","105.00","180.00","400.00","0.00","0.00","0.30","3.00","3.00"
		}
		,
		{
			"Peas:(boiled)",
			"100.00","68.00","3.00","13.00","1.40","0.00","1.80","25.00","67.00","96.00","270.00","500.00","0.10","0.00","1.00","8.00"
		}
		,
		{
			"Watermelon",
			"925.00","120.00","2.00","29.00","3.60","1.00","1.20","63.00","96.00","600.00","2.00","520.00","0.00","0.00","0.20","6.00"
		}
		,
		{
			"Rice",
			"191.00","692.00","14.00","150.00","0.30","0.00","1.60","46.00","258.00","247.00","4.00","0.00","0.00","0.00","1.60","0.00"
		}
		,
		{
			"Tomatoe Paste",
			"17.00","15.00","0.00","4.00","0.00","0.00","0.10","2.00","3.00","160.00","260.00","300.00","0.00","0.00","0.40","2.00"
		}
		,
		{
			"Apricot",
			"114.00","55.00","1.00","14.00","0.70","0.00","0.50","18.00","30.00","280.00","1.00","2900.00","0.00","0.00","0.70","10.00"
		}
		,
		{
			"Peach",
			"114.00","35.00","1.00","10.00","0.60","0.00","0.50","9.00","22.00","31.00","5.00","1320.00","0.00","0.00","1.00","7.00"
		}
		,
		{
			"Persimmon",
			"125.00","75.00","1.00","20.00","2.00","0.00","0.40","7.00","28.00","310.00","1.00","2710.00","0.00","0.00","0.10","11.00"
		}
		,
		{
			"Olive",
			"65.00","72.00","1.00","3.00","0.80","10.00","1.20","65.00","13.00","45.00","1400.00","200.00","0.00","0.00","0.00","0.00"
		}
		,
		{
			"Orange",
			"180.00","60.00","2.00","16.00","1.00","0.00","0.50","50.00","40.00","300.00","0.00","240.00","1.00","0.00","0.30","75.00"
		}
		,
		{
			"Whole Wheat Bread",
			"91.00","220.00","10.00","43.00","14.00","2.80","2.10","90.00","216.00","162.00","576.00","0.00","0.24","0.20","2.60","0.00"
		}
		,
		{
			"Almond",
			"50.00","304.00","9.30","9.30","1.30","27.00","2.35","116.00","253.00","386.00","1.40","0.00","0.15","0.43","1.70","0.00"
		}
		,
		{
			"Pistachio",
			"25.00","65.00","2.00","4.00","1.00","15.00","0.50","13.00","40.00","30.00","1.00","0.00","0.05","0.05","0.50","0.00"
		}
		,
		{
			"Peanut",
			"50.00","290.00","13.00","9.00","1.20","25.00","1.00","37.00","200.00","337.00","2.00","0.00","0.20","0.10","8.60","0.00"
		}
	} ;

	for ( int i = 0 ; i < 64 ; i++ )
	for ( int j = 0 ; j < 17 ; j++ )
	{
		SortedStringGrid1->Cells[j][2 + i] = nutriens[i][j] ;
	}


	for( int i = 1 ; i < SortedStringGrid1->RowCount; i++ )
	{
		SortedStringGrid1->RowId[i] = i - 1 ;
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Help1Click(TObject *Sender)
{
	Application->HelpCommand(HELP_CONTENTS, 0);	
}
//---------------------------------------------------------------------------

