//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "MultimediaTimer"
#pragma link "WaveDevice"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------

__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
	int i = 0 ;
	WaveDevice1->WaveInDeviceID = i ;
	while( WaveDevice1->WaveInDeviceID == i )
	{
		ComboBox1->Items->Append( WaveDevice1->WaveInDeviceName ) ;
		WaveDevice1->WaveInDeviceID = ++i ;
	}
	WaveDevice1->WaveInDeviceID = 0 ;
	ComboBox1->ItemIndex = 0 ;


	i = 0 ;
	WaveDevice1->WaveOutDeviceID = i ;
	while( WaveDevice1->WaveOutDeviceID == i )
	{
		ComboBox2->Items->Append( WaveDevice1->WaveOutDeviceName ) ;
		WaveDevice1->WaveOutDeviceID = ++i ;
	}
	WaveDevice1->WaveOutDeviceID = 0 ;
	ComboBox2->ItemIndex = 0 ;

	mIsPaused = false ;
	mIsRepeating = false ;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MultimediaTimer1Timer(TObject *Sender)
{
	static void *in_buffer, *out_buffer ;
	static int buffer_length, bytes_recorded, bytes_played, position, tag ;

	if ( mWaveOutBufferCount < TBDelay->Position - 2 )
		WaveDevice1->WaveOutStop() ;

	if( WaveDevice1->WaveOutStopped  &&  mWaveOutBufferCount > TBDelay->Position )
		WaveDevice1->WaveOutStart() ;

	if( WaveDevice1->WaveOutPop( out_buffer, buffer_length, bytes_played, position, tag ) )
	{
		mWaveOutBufferCount-- ;
		WaveDevice1->WaveInPush( out_buffer, 4410, tag ) ;
	}

	if( WaveDevice1->WaveInPop( in_buffer, buffer_length, bytes_recorded, position, tag ) )
	{
		if( mWaveOutBufferCount <= TBDelay->Position )
		{
			if( WaveDevice1->WaveOutPush( in_buffer, bytes_recorded, tag ) )
				mWaveOutBufferCount++ ;
		}
		else
		{
			WaveDevice1->WaveInPush( in_buffer, 4410, tag ) ;
		}
	}

	LBActualDelay->Caption = mWaveOutBufferCount / 10.0 ;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCloseQuery(TObject *Sender, bool &CanClose)
{
	SPStop->Click() ;
	CanClose = ! mIsRepeating ;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ComboBox1Change(TObject *Sender)
{
	WaveDevice1->WaveInDeviceID = ComboBox1->ItemIndex ;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ComboBox2Change(TObject *Sender)
{
	WaveDevice1->WaveOutDeviceID = ComboBox2->ItemIndex ;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SPStopClick(TObject *Sender)
{
	void *buffer ;
	int buffer_length, bytes_recorded, bytes_played, position, tag ;

	MultimediaTimer1->Active = false ;

	WaveDevice1->WaveInStop() ;
	WaveDevice1->WaveInReset() ;
	WaveDevice1->WaveInActive = false ;

	WaveDevice1->WaveOutStop() ;
	WaveDevice1->WaveOutReset() ;
	WaveDevice1->WaveOutActive = false ;

	while( WaveDevice1->WaveOutPop( buffer, buffer_length, bytes_played, position, tag ) )
	{
		delete [] buffer ;
	}

	while( WaveDevice1->WaveInPop( buffer, buffer_length, bytes_recorded, position, tag ) )
	{
		delete [] buffer ;
	}

	ComboBox1->Enabled = true ;
	ComboBox2->Enabled = true ;

	mIsRepeating = false ;
	mIsPaused = false ;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SPStartClick(TObject *Sender)
{
	if( mIsRepeating )
		return ;

	if( mIsPaused )
	{
		MultimediaTimer1->Active = true ;
		WaveDevice1->WaveInStart() ;
		WaveDevice1->WaveOutStart() ;
		mIsRepeating = true ;
		return ;
	}

	WaveDevice1->WaveInActive = true ;
	if( ! WaveDevice1->WaveInActive )
	{
		ShowMessage("Wavein Device not Present") ;
		SPStop->Down = true ;
		return ;
	}

	WaveDevice1->WaveOutActive = true ;
	if( ! WaveDevice1->WaveOutActive )
	{
		WaveDevice1->WaveInActive = false ;
		ShowMessage("Waveout Device not Present") ;
		SPStop->Down = true ;
		return ;
	}

	for( int tag = 0 ; tag < 150 ; tag++ )
	{
		char *buffer = new char[4410] ;

		if( ! WaveDevice1->WaveInPush( buffer, 4410, tag ) )
		{
			delete [] buffer ;
		}
	}

	ComboBox1->Enabled = false ;
	ComboBox2->Enabled = false ;

	mWaveOutBufferCount = 0 ;

	WaveDevice1->WaveInStart() ;
	WaveDevice1->WaveOutStart() ;

	mIsRepeating = true ;
	MultimediaTimer1->Active = true ;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::SBPauseClick(TObject *Sender)
{
	if( ! mIsRepeating )
	{
		return ;
	}

	MultimediaTimer1->Active = false ;
	WaveDevice1->WaveInStop() ;
	WaveDevice1->WaveOutStop() ;
	mIsPaused = true ;
	mIsRepeating = false ;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::TBDelayChange(TObject *Sender)
{
	LBDelay->Caption = TBDelay->Position / 10.0 ;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Help1Click(TObject *Sender)
{
	Application->HelpCommand(HELP_CONTENTS, 0);
}
//---------------------------------------------------------------------------

